unit UnitHtmlClip;

{
    purpose:
    extract the HTML code from and HTML Clip
    or
    encode the HTML into an HTML Clip
}

interface

type THTMLCLip = class
    class function extractHTMLfromClip(clip : string ): string;
    class function HTMLtoHTMLClip(html : string) : ansistring;
end;

implementation

uses System.Classes, UnitToken, SysUtils, System.StrUtils, UnitMisc, System.AnsiStrings;

class function THTMLCLip.extractHTMLfromClip(clip : string ): string;
var strReader : TStringReader; // StreamReader was failing for ReadLine
    line : string;
    idxStart, idxEnd, sz : integer;

    function extractNumber(s : string) : Integer;
    var numstr : string;
    begin
         numstr := UnitToken.TokenString(s, ':');
         try
            result := strtoint(s);
         except

         end;
    end;
begin
    strReader := TStringReader.Create(clip);

    line := strReader.ReadLine; // version
    line := strReader.ReadLine; // start HTML
    idxStart := extractNumber(line);
    line := strReader.ReadLine; // end HTML;
    idxEnd := extractNumber(line);
    sz :=  idxEnd - idxstart;

    result := System.StrUtils.MidStr(clip, idxStart+1, sz);

    myfree(strReader);
end;


class function THTMLCLip.HTMLtoHTMLClip(html : string) : ansistring;
const NL = #13#10;
    HTML_Header =
        'version:0.9' + NL +     // 13 bytes
        'StartHTML:00000000' + NL +         // 18 bytes
        'EndHTML:00000000' + NL +            // 16 bytes
        'StartFragment:00000000' + NL +     // 22 bytes
        'EndFragment:00000000' + NL;         // 20 bytes
var startHTML, endHTML : integer;
    startFrag, endFrag : integer;
    htmlutf8 : ansistring;
    term : ansistring;

    function pad(i : integer) : ansistring;
    begin
        result := Format('%.*d', [8, i]);
    end;
begin
    htmlutf8 := Utf8Encode(html);

    startHTML := length(HTML_Header);
    endHTML := length(HTML_Header) + length(htmlutf8);
    term := '<body>';
    startFrag := pos(term, lowercase(html));
    term := '</body>';
    endFrag := pos(term, lowercase(html)) + length(term);

    if startFrag = -1 then begin
        term := '<html>';
        startFrag := pos(term, lowercase(html));
        term := '</html>';
        endFrag := pos(term, lowercase(html)) + length(term);
    end;


    result :=
        'version:0.9' + NL +     // 13 bytes
        'StartHTML:' +   pad(startHTML) + NL +         // 18 bytes
        'EndHTML:' + pad(endHTML)+ NL +            // 16 bytes
        'StartFragment:' + pad(StartFrag)   + NL +     // 22 bytes
        'EndFragment:'+  pad(endFrag)+ NL +         // 20 bytes
        htmlutf8;


end;

end.
